<template>
    <div>
        <QuestBtn @click="isOpened = !isOpened" :disabled="disabled">
            {{ isOpened ? "Свернуть Карту" : "Открыть карту" }}
        </QuestBtn>
        <br />
        <div
            style="display: inline-block; width: 500px; height: 250px"
            v-if="isOpened"
            :key="isOpened"
        >
            Отметьте нужное место на карте:<br />
            <yandex-map
                style="width: 100%; height: 100%"
                @map-was-initialized="initHandler"
                @click="onClick"
                :coords="markCoords"
                :zoom="15"
                :controls="[]"
                :options="{
                    suppressMapOpenBlock: true,
                    autoFitToViewport: 'always',
                }"
                :cluster-options="{ name: true }"
            >
                <ymap-marker
                    marker-id="1"
                    marker-type="placemark"
                    :coords="markCoords"
                    cluster-name="1"
                    :marker-fil="{ color: '$ff0000' }"
                ></ymap-marker>
                <!--Markers-->
            </yandex-map>
            <QuestBtn
                :disabled="loading || !isChanged || !isLoaded"
                @click="mapFields"
            >
                Заполнить поля ({{
                    Object.values(locGeoData)
                        .filter((e) => !!e)
                        .join(" ")
                }})
            </QuestBtn>
        </div>
    </div>
</template>

<script>
import { yandexMap, ymapMarker } from "vue-yandex-maps";
import { getDiffs } from "@/utils";
import QuestBtn from "@/components/QuestBtn";

export default {
    name: "QuestMap",
    components: { QuestBtn, yandexMap, ymapMarker },
    props: { value: Object, disabled: Boolean },
    data: () => ({
        markCoords: [null, null],
        isLoaded: false,
        $myMap: null,
        loading: false,
        locGeoData: {
            house: "",
            district: "",
            locality: "",
            country: "",
            street: "",
        },
        isOpened: false,
    }),
    methods: {
        mapFields() {
            this.geoData = { ...this.geoData, ...this.locGeoData };
        },
        addControls() {
            const searchControl = new window.ymaps.control.SearchControl({
                options: {
                    provider: "yandex#map",
                    noPlacemark: true,
                    noCentering: true,
                },
            });
            searchControl.events.add(
                "resultshow",
                this.searchShowHandler,
                this
            );

            const geolocationControl = new window.ymaps.control.GeolocationControl(
                {
                    options: {
                        noPlacemark: true,
                        noCentering: true,
                    },
                }
            );

            geolocationControl.events.add(
                "locationchange",
                this.locationChangeHandler,
                this
            );

            this.$myMap.controls.add(searchControl);
            this.$myMap.controls.add(geolocationControl);
        },
        async initHandler(myMap) {
            this.$myMap = myMap;
            this.addControls();

            const { house, district, locality, country, street } = this.geoData;
            const isExist = [house, district, locality, country, street].find(
                (e) => !!e
            );
            if (isExist) {
                await this.getExistLocation(country, locality, street, house);
            } else await this.getGeoLocation();

            this.isLoaded = true;
        },
        async getExistLocation(country, locality, street, house) {
            const line = [country, locality, street, house].join(" ");

            const res = await window.ymaps.geocode(line);

            const n = res.geoObjects.get(0);
            if (n) this.markCoords = n.geometry.getCoordinates();
        },
        searchShowHandler(e) {
            const res = e.originalEvent.target.getResultsArray()[
                e.get("index")
            ];
            this.markCoords = res.geometry._coordinates;
        },

        async getGeoLocation() {
            const geo = await window.ymaps.geolocation.get({
                provider: "auto",
                mapStateAutoApply: true,
            });
            this.markCoords = geo.geoObjects.position;
        },

        async locationChangeHandler(e) {
            this.markCoords = e.get("position");
        },

        async onClick(e) {
            this.markCoords = e.get("coords");
        },
        async getNames(coords, kind) {
            let options = {};
            if (kind) options = { kind };
            const res = await window.ymaps.geocode(coords, options);

            const nearest = res.geoObjects.get(0);
            if (nearest) {
                const name = nearest.properties.get("name");
                return name || "";
            }
            return "";
        },
        async getFullInfo(coords) {
            try {
                this.loading = true;

                let house = await this.getNames(coords, "house");
                const district = await this.getNames(coords, "district");
                const locality = await this.getNames(coords, "locality");
                const country = await this.getNames(coords, "country");
                const street = await this.getNames(coords, "street");

                if (house) house = house.split(", ")[1];

                this.locGeoData = {
                    house,
                    district,
                    locality,
                    country,
                    street,
                };
            } finally {
                this.loading = false;
            }
        },
    },
    computed: {
        geoData: {
            get() {
                return this.value;
            },
            set(value) {
                this.$emit("input", value);
            },
        },
        diffs() {
            return getDiffs(this.geoData, this.locGeoData);
        },
        isChanged() {
            return !!Object.entries(this.diffs).length;
        },
    },
    watch: {
        markCoords(value) {
            this.getFullInfo(value);
        },
        geoData: {
            deep: true,
            handler({ country, locality, street, house }) {
                if (this.isLoaded && this.isChanged)
                    this.getExistLocation(country, locality, street, house);
            },
        },
    },
};
</script>

<style scoped></style>
